#include "auto-alias.h"

#define LINKER_ALIAS_GCC 1

#ifdef HAVE_LINKER_ALIAS
# if HAVE_LINKER_ALIAS == LINKER_ALIAS_GCC
#  define LINKER_ALIAS_ATTRIB(name) __attribute__((__alias__ (#name) ))
# else
#  error not implemented
# endif
# define ALIAS_LINKAGE static
# define LINKER_ALIAS_SPLIT(retcode,x,y,args) \
   retcode x##_##y args LINKER_ALIAS_ATTRIB(x##y)
# define LINKER_ALIAS_WRAP(retcode,fn,args) \
   retcode wrap_##fn args LINKER_ALIAS_ATTRIB(fn)
# define SPLIT_int_void(x,y) /* LINKER_ALIAS_SPLIT(int,x,y,(void)) */
# define SPLIT_int_int_int(x,y) /*LINKER_ALIAS_SPLIT(int,x,y,(int a,int b)) */
# define SPLIT_int_constcharp(x,y) /*LINKER_ALIAS_SPLIT(int,x,y,(const char*))*/
#else
# define LINKER_ALIAS_SPLIT(rettype,x,y,args) rettype x##_##y args
# define LINKER_ALIAS_WRAP(rettype,fn,args) rettype wrap_##fn args
# define ALIAS_LINKAGE /* global */
# define SPLIT_int_void(x,y) LINKER_ALIAS_SPLIT(int,x,y,(void))\
   { return x##y(); }
# define SPLIT_int_int_int(x,y) LINKER_ALIAS_SPLIT(int,x,y,(int a,int b))\
   { return x##y(a,b); }
# define SPLIT_int_constcharp(x,y) LINKER_ALIAS_SPLIT(int,x,y,(const char *a))\
   { return x##y (a); }
#endif

