#! /bin/sh

cat >auto-aliastest.c <<EOF
#include <sys/types.h>
#include <unistd.h>
int get_pid(void) __attribute__((alias ("getpid") ));
int get_uid(void) __attribute__((alias ("getuid") ));
extern int test(void);
int main(void)
{
	if (getpid()!=get_pid())
		return 1;
	if (getuid()!=get_uid())
		return 1;
	return test();
}
EOF
cat >auto-aliastest2.c <<EOF
#include <sys/types.h>
static int get_pid(void) __attribute__((alias ("getpid") ));
static int get_uid(void) __attribute__((alias ("getuid") ));
int test(void)
{
	if (getpid()!=get_pid())
		return 1;
	if (getuid()!=get_uid())
		return 1;
	return 0;
}
EOF
echo "Testing whether __attribute__(alias) works:" >&2
if ./auto-compile.sh -c auto-aliastest.c >&2 ; then
 if ./auto-compile.sh -c auto-aliastest2.c >&2 ; then
  if ./auto-link.sh auto-aliastest auto-aliastest.o auto-aliastest2.o >&2 ; then
   if ./auto-aliastest >&2 ; then
    ok=1
   fi
  fi
 fi
fi
rm -f auto-aliastest* >&2
if test x$ok = x1; then
echo "  ... yes, __attribute__(alias) works." >&2
cat <<EOF
#define HAVE_LINKER_ALIAS LINKER_ALIAS_GCC /* systype-info */
EOF
else
echo "  ... no, __attribute__(alias) fails. Oh well." >&2
fi
