#! /bin/sh

. checkdir/prepare

cat >test1 <<EOF
From: XYZ-f@ohse.de (Uwe Ohse)
To: XYZ-t@ohse.de
Subject: test
Date: Mon, 5 Feb 2001 10:27:00 -0000
Message-ID: <20010205143956.26353.qmail@idhost.ohse.de>

Test
EOF

cat >test2 <<EOF
From: XYZ-tf@AAA.ohse.de
To: XYZ-tt@AAA.ohse.de
Subject: test
Date: Mon, 5 Feb 2001 10:27:00 -0000
Message-ID: <20010205143956.26353.qmail@idhost.ohse.de>

Test
EOF
cat >test3 <<EOF
Sender: XYZ-ts@AAA.ohse.de
To: XYZ-tt@AAA.ohse.de
Subject: test
Date: Mon, 5 Feb 2001 10:27:00 -0000
Message-ID: <20010205143956.26353.qmail@idhost.ohse.de>

Test
EOF
set +e

echo '--- usendmail works.'
run "" --debug XYZ-et@ohse.de <test1
echo "------"
run "" --address-debug XYZ-et@ohse.de <test1
echo "--- usendmail behaviour in case no address is given"
run "" --debug XYZ-et@ohse.de <test1
echo "------"
run "" --address-debug <test1
echo '--- usendmail -t works.' # does the same, -t is qmail-inject
run "" --debug -t <test1
echo "------"
run "" --address-debug -t <test1
echo '--- usendmail handles multiple commandline addresses.'
run "" --address-debug XYZ-123@ohse.de XYZ-456@ohse.de <test1
echo '--- usendmail parses malformed addresses.'
run "" --address-debug 'XYZ-123@ohse.de,XYZ-456@ohse.de' <test1
run "" --address-debug ',XYZ-123@ohse.de,,XYZ-456@ohse.de,' <test1
# the next one is _really_ malformed. No dot between atom and quoted-string.
run "" --address-debug 'XYZ-"123@ohse.de,,XYZ-456"@ohse.de' <test1
run "" --address-debug XYZ,XYZ-1@ohse.de XYZ-2@ohse.de <test1
echo '--- usendmail capitel A bug in address is fixed.'
run "" --address-debug XYZ-56@A.de XYZ-57@AAA.de <test1
echo '--- usendmail capitel A bug in env. sender creation (from) is fixed.'
run "" --debug XYZ@ohse.de <test2
echo '--- usendmail capitel A bug in env. sender creation (sender) is fixed.'
run "" --debug XYZ@ohse.de <test3 |grep -v ^From:
